#include "ether_reg.h"

void receive(int* len, BYTE* buffer) {
  WORD packetaddr;
  NICHDR nichdr;
  BYTE temp;
  int i;

  /*get size of header*/
  getnic((WORD)(innic(TBCR1)-1)<<8, (BYTE*)&nichdr, sizeof(NICHDR));

  *len = nichdr.len;

  packetaddr = ((innic(TBCR1)-1)<<8)+sizeof(NICHDR);
  getnic((WORD)packetaddr, (BYTE*)buffer, *len);

  outnic(ISR,0xff);

  for(i=14;i < *len;i=i+2){
    temp=buffer[i];
    buffer[i]=buffer[i+1];
    buffer[i+1]=temp;
  }
}

/* Get a packet from a given address in the NIC's RAM */ 
void getnic(WORD addr, BYTE data[], WORD len)
{
    register int count;
    register WORD *dataw;

    count = WORDMODE ? len>>1 : len;    /* Halve byte count if word I/P */
    outnic(ISR, 0x40);                  /* Clear remote DMA interrupt flag */
    outnic(RBCR0, len&0xff);            /* Byte count */
    outnic(RBCR1, len>>8);
    outnic(RSAR0, addr&0xff);           /* Data addr */
    outnic(RSAR1, addr>>8);
    outnic(CMDR, 0x0a);                 /* Start, DMA remote read */
#if WORDMODE
    dataw = (WORD *)data;               /* Use pointer for speed */
    while(count--)                      /* Get words */
        *dataw++ = innic(DATAPORT);
    if (len & 1)                        /* If odd length, do last byte */
        *(BYTE *)dataw = innic(DATAPORT);
#else
    while(count--)                      /* Get bytes */
        *data++ = innic(DATAPORT);
#endif

    /*    print("ISR After Reception: ");
    putnum(innic(ISR));
    print("\r\nCount: ");
    putnum(count);
    print("\r\n");
    */
    
}

